> For the complete documentation index, see [llms.txt](https://docs.file0.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.file0.dev/sdk/list-and-search.md).

# List and Search

```typescript
import { f0 } from 'file0';

// List first 100 files
const { files, cursor, hasMore } = await f0.list();

// List the second 100 files
if (hasMore) {
  const { files, cursor, hasMore } = await f0.list({ cursor });
}

// List the first 1000 files
const { files, cursor, hasMore } = await f0.list({ limit: 1000 });

// List files that's name starts with 'user123/'
// and ends with '.png'
// and contains 'profile'
const files = await f0.list({
  endsWith: '.png', 
  startsWith: 'user123/',
  contains: 'profile'
});
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.file0.dev/sdk/list-and-search.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
